Blob


1 #!/bin/sh
2 #
3 # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 #
5 # Permission to use, copy, modify, and distribute this software for any
6 # purpose with or without fee is hereby granted, provided that the above
7 # copyright notice and this permission notice appear in all copies.
8 #
9 # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
17 regress_run_only=""
19 export GIT_AUTHOR_NAME="Flan Hacker"
20 export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 export GOT_AUTHOR_8="flan_hac"
25 export GOT_AUTHOR_11="flan_hacker"
26 export GOT_LOG_DEFAULT_LIMIT=0
27 export GOT_TEST_ROOT="/tmp"
28 export GOT_IGNORE_GITCONFIG=1
29 export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
31 export LC_ALL=C
33 export MALLOC_OPTIONS=S
35 git_init()
36 {
37 git init -q "$1"
39 # Switch the default branch to match our test expectations if needed.
40 # Only need to change HEAD since 'git init' did not create any refs.
41 # Relying on implementation details of 'git init' is no problem for us.
42 # We want to be alerted when Git changes fundamental assumptions such
43 # as what an empty repository looks like and where the default branch
44 # is set. In such cases Got's own tooling might well need to change
45 # its behaviour, too, and our tests should fail.
46 # TODO: Update all tests to assume 'main' instead of 'master' and
47 # switch to main here, to match Got's own default.
48 echo "ref: refs/heads/master" > "$1/.git/HEAD"
49 }
51 maybe_pack_repo()
52 {
53 local repo="$1"
54 if [ -n "$GOT_TEST_PACK" ]; then
55 arg=""
56 if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
57 arg="-D"
58 fi
60 (cd $repo && gotadmin pack -a $arg > /dev/null)
61 (cd $repo && gotadmin cleanup -a -q)
62 fi
63 }
65 git_commit()
66 {
67 local repo="$1"
68 shift
69 (cd $repo && git commit --author="$GOT_AUTHOR" -q -a "$@")
70 maybe_pack_repo $repo
71 }
73 git_rm()
74 {
75 local repo="$1"
76 shift
77 (cd $repo && git rm -q "$@")
78 }
80 git_rmdir()
81 {
82 local repo="$1"
83 shift
84 (cd $repo && git rm -q -r "$@")
85 }
87 git_show_head()
88 {
89 local repo="$1"
90 (cd $repo && git show --no-patch --pretty='format:%H')
91 }
93 git_show_branch_head()
94 {
95 local repo="$1"
96 local branch="$2"
97 (cd $repo && git show --no-patch --pretty='format:%H' $branch)
98 }
101 git_show_author_time()
103 local repo="$1"
104 local object="$2"
105 (cd $repo && git show --no-patch --pretty='format:%at' $object)
108 git_show_tagger_time()
110 local repo="$1"
111 local tag="$2"
112 (cd $repo && git cat-file tag $tag | grep ^tagger | \
113 sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2)
116 git_show_parent_commit()
118 local repo="$1"
119 local commit="$2"
120 (cd $repo && git show --no-patch --pretty='format:%P' $commit)
123 git_show_tree()
125 local repo="$1"
126 (cd $repo && git show --no-patch --pretty='format:%T')
129 trim_obj_id()
131 local trimcount=$1
132 local id=$2
134 local pat=""
135 while [ "$trimcount" -gt 0 ]; do
136 pat="[0-9a-f]$pat"
137 trimcount=$((trimcount - 1))
138 done
140 echo ${id%$pat}
143 git_commit_tree()
145 local repo="$1"
146 local msg="$2"
147 local tree="$3"
148 (cd $repo && git commit-tree -m "$msg" "$tree")
151 git_fsck()
153 local testroot="$1"
154 local repo="$2"
156 (cd $repo && git fsck --strict \
157 > $testroot/fsck.stdout 2> $testroot/fsck.stderr)
158 ret=$?
159 if [ $ret -ne 0 ]; then
160 echo -n "git fsck: "
161 cat $testroot/fsck.stderr
162 echo "git fsck failed; leaving test data in $testroot"
163 return 1
164 fi
166 return 0
169 make_test_tree()
171 repo="$1"
173 echo alpha > $repo/alpha
174 echo beta > $repo/beta
175 mkdir $repo/gamma
176 echo delta > $repo/gamma/delta
177 mkdir $repo/epsilon
178 echo zeta > $repo/epsilon/zeta
181 make_single_file_repo()
183 repo="$1"
184 file="$2"
186 mkdir $repo
187 git_init $repo
188 echo "this is file $file" > $repo/$file
189 (cd $repo && git add .)
190 git_commit $repo -m "intialize $repo with file $file"
193 get_loose_object_path()
195 local repo="$1"
196 local id="$2"
197 local id0=`trim_obj_id 38 $id`
198 local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
199 echo "$repo/.git/objects/$id0/$idrest"
202 get_blob_id()
204 repo="$1"
205 tree_path="$2"
206 filename="$3"
208 got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
209 cut -d' ' -f 1
212 test_init()
214 local testname="$1"
215 local no_tree="$2"
216 if [ -z "$testname" ]; then
217 echo "No test name provided" >&2
218 return 1
219 fi
220 local testroot=`mktemp -d \
221 "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXXXX"`
222 mkdir $testroot/repo
223 git_init $testroot/repo
224 if [ -z "$no_tree" ]; then
225 make_test_tree $testroot/repo
226 (cd $repo && git add .)
227 git_commit $testroot/repo -m "adding the test tree"
228 fi
229 touch $testroot/repo/.git/git-daemon-export-ok
230 echo "$testroot"
233 test_cleanup()
235 local testroot="$1"
237 git_fsck $testroot $testroot/repo
238 ret=$?
239 if [ $ret -ne 0 ]; then
240 return $ret
241 fi
243 rm -rf "$testroot"
246 test_parseargs()
248 while getopts qr: flag; do
249 case $flag in
250 q) export GOT_TEST_QUIET=1
251 ;;
252 r) export GOT_TEST_ROOT=${OPTARG%/}
253 ;;
254 ?) echo "Supported options:"
255 echo " -q: quiet mode"
256 echo " -r PATH: use PATH as test data root directory"
257 exit 2
258 ;;
259 esac
260 done
261 shift $(($OPTIND - 1))
262 regress_run_only="$@"
263 } >&2
265 run_test()
267 testfunc="$1"
269 if [ -n "$regress_run_only" ]; then
270 case "$regress_run_only" in
271 *$testfunc*) ;;
272 *) return ;;
273 esac
274 fi
276 if [ -z "$GOT_TEST_QUIET" ]; then
277 echo -n "$testfunc "
278 fi
279 $testfunc
282 test_done()
284 local testroot="$1"
285 local result="$2"
286 if [ "$result" = "0" ]; then
287 test_cleanup "$testroot" || return 1
288 if [ -z "$GOT_TEST_QUIET" ]; then
289 echo "ok"
290 fi
291 elif echo "$result" | grep -q "^xfail"; then
292 # expected test failure; test reproduces an unfixed bug
293 echo "$result"
294 test_cleanup "$testroot" || return 1
295 else
296 echo "test failed; leaving test data in $testroot"
297 fi